package ch.unibe.iam.mcast.client;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.Inet4Address;
import java.net.InetSocketAddress;
import java.net.MulticastSocket;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

public class DummyClient {
	
	private static NetworkInterface determineInterface() throws SocketException {
		NetworkInterface ret=null;
		for (Enumeration ne=NetworkInterface.getNetworkInterfaces(); ne.hasMoreElements();) {
			NetworkInterface ni=(NetworkInterface) ne.nextElement();
//			System.out.println("iface: "+ni.getName()+" display name: "+ni.getDisplayName());
			
			if (ni.getDisplayName().startsWith("TAP-Win32")) {
				ret=ni;
			}
		}
		return ret;
	}
	
	public static void main(String argv[]) throws IOException, ReservationSystemFailureException, InterruptedException {
		InetSocketAddress groupSocketAddress=new InetSocketAddress(Inet4Address.getByAddress(new byte[]{(byte) 239,0,0,9}),1234);
		MulticastSocket ms=new MulticastSocket(groupSocketAddress.getPort());
		
		NetworkInterface ni=determineInterface();
		if (ni != null) {
			ms.setNetworkInterface(ni);
		}
		ms.joinGroup(groupSocketAddress.getAddress());
		MulticastReservation mr=ReservationManager.createSession(groupSocketAddress, 0);
		
		mr.reserveResources(1*1024*1024, 300, 20);
		byte[] packetBuffer=new byte[65536];
		DatagramPacket dp=new DatagramPacket(packetBuffer, packetBuffer.length);
		
		boolean terminate=false;
		
		byte toSend[]=(Inet4Address.getLocalHost().toString()+" is alive").getBytes("UTF-8");
		
		System.arraycopy(toSend, 0, packetBuffer, 0, toSend.length);
		
		dp.setData(packetBuffer);
		dp.setLength(toSend.length);
		dp.setSocketAddress(groupSocketAddress);		
		ms.setTimeToLive(255);
		
		Thread.sleep(1000);
		ms.send(dp);
		
		dp.setLength(packetBuffer.length);
		
		do {
			ms.receive(dp);
			//byte data[]=dp.getData();
			int len=dp.getLength();
			String received=new String(packetBuffer,0,len,"UTF-8");
			System.out.println("received trough multicast socket: "+received);
			// TODO set terminate to true to end the loop
		} while (!terminate);
		
		
		
		mr.release();
		ms.close();
		
		
	}

}