package ch.unibe.iam.mcast.client;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.Inet4Address;
import java.net.InetSocketAddress;
import java.net.MulticastSocket;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Enumeration;

public class DummyClientForPerformanceTest {
	
	private static NetworkInterface determineInterface() throws SocketException {
		NetworkInterface ret=null;
		for (Enumeration ne=NetworkInterface.getNetworkInterfaces(); ne.hasMoreElements();) {
			NetworkInterface ni=(NetworkInterface) ne.nextElement();
//			System.out.println("iface: "+ni.getName()+" display name: "+ni.getDisplayName());
			
			if (ni.getDisplayName().startsWith("TAP-Win32")) {
				ret=ni;
			}
		}
		return ret;
	}
	
	public static void main(String argv[]) throws IOException, ReservationSystemFailureException, InterruptedException {
		for (int i=0; i<20; i++) {
			InetSocketAddress groupSocketAddress=new InetSocketAddress(Inet4Address.getByAddress(new byte[]{(byte) 239,0,0,(byte)i}),1234);
			joinAndSend(groupSocketAddress);
		}
		
		
	}

	private static void joinAndSend(InetSocketAddress groupSocketAddress) throws IOException, ReservationSystemFailureException, SocketException, UnsupportedEncodingException, UnknownHostException, InterruptedException {
		MulticastSocket ms=new MulticastSocket(groupSocketAddress.getPort());
		
		MulticastReservation mr=ReservationManager.createSession(groupSocketAddress, 0);
		
		NetworkInterface ni=determineInterface();
		if (ni != null) {
			ms.setNetworkInterface(ni);
		}
		ClientUtil.performanceLog("MULTICAST", "group "+groupSocketAddress.getAddress().getHostAddress()+" joined");
		ms.joinGroup(groupSocketAddress.getAddress());
		
		Thread.sleep(2000);
		
		ClientUtil.performanceLog("EUQOS", "performing reservation for group "+groupSocketAddress.getAddress().getHostAddress());
		mr.reserveResources(1*1024*1024, 300, 20);
		ClientUtil.performanceLog("EUQOS", "performed reservation for group "+groupSocketAddress.getAddress().getHostAddress());
		byte[] packetBuffer=new byte[65536];
		DatagramPacket dp=new DatagramPacket(packetBuffer, packetBuffer.length);
		
//		boolean terminate=false;
		
		byte toSend[]=(Inet4Address.getLocalHost().toString()+" is alive").getBytes("UTF-8");
		
		System.arraycopy(toSend, 0, packetBuffer, 0, toSend.length);
		
		dp.setData(packetBuffer);
		dp.setLength(toSend.length);
		dp.setSocketAddress(groupSocketAddress);		
		ms.setTimeToLive(255);
		
		Thread.sleep(20000);
		ms.send(dp);
		
//		dp.setLength(packetBuffer.length);
//		
//		do {
//			ms.receive(dp);
//			//byte data[]=dp.getData();
//			int len=dp.getLength();
//			String received=new String(packetBuffer,0,len,"UTF-8");
//			System.out.println("received trough multicast socket: "+received);
//			// TODO set terminate to true to end the loop
//		} while (!terminate);
		
		
		
		mr.release();
		ms.close();
	}

}
