/*
 * Created on Oct 28, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.hivemind.component;

import java.io.IOException;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.UnknownHostException;
import java.util.List;
import java.util.StringTokenizer;

import org.apache.hivemind.events.RegistryShutdownListener;

import ch.unibe.iam.mcast.core.MulticastRoutingTable;
import ch.unibe.iam.mcast.hivemind.component.euqos.QCMComponent;
import ch.unibe.iam.mcast.hivemind.component.iface.MulticastRouter;
import ch.unibe.iam.mcast.hivemind.config.PeerConfig;
import ch.unibe.iam.mcast.router.EUQoSMulticastPeer;
import ch.unibe.iam.mcast.router.QoSMulticastPeer;
import ch.unibe.iam.mcast.router.qos.QoSInformation;
import ch.unibe.iam.mcast.router.qos.QoSRequirement;
import ch.unibe.iam.mcast.router.qos.QoSReservationService;
import ch.unibe.iam.mcast.router.qos.QosReservationException;
import ch.unibe.iam.mcast.router.qos.ReservedResources;

/**
 * @author root
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class RouterComponent implements RegistryShutdownListener, MulticastRouter {

	private static final String DEFAULT_QCM_USERNAME = "dummyauth10@euqos.org";

	private static final String DEFAULT_QCM_PASSWORD = "password";

	private static final String ENV_SHOW_QCM_CONSOLE = "SHOW_QCM_CONSOLE";

	private static final String ENV_QCM_PASSWORD = "QCM_PASSWORD";

	private static final String ENV_QCM_USERNAME = "QCM_USERNAME";

	private static final String ENV_USE_EUQOS = "USE_EUQOS";

	// private static final String ENV_PEER_ID = "PEER_ID";

	private static final String ENV_QOS_GROUPS = "QOS_GROUPS";

	private static final String ENV_MASTER_NODE = "MASTER_NODE";

	private static final String ENV_BIND_ADDRESS = "BIND_ADDRESS";

	private static final String ENV_TEST_CODE = "TEST_CODE";

	// private static final Map<String,QoSRequirement> reqMapping=new
	// HashMap<String, QoSRequirement>();
	private final QoSReservationService reservationService;

	// static {
	// reqMapping.put("BE", null);
	// reqMapping.put("MEDIUM",QoSRequirement.MEDIUM);
	// reqMapping.put("HIGH",QoSRequirement.HIGH);
	// }

	private final QoSMulticastPeer peer;

	private final EUQoSMulticastPeer testPeer;

	public RouterComponent(List config) throws IOException {
		boolean test = "true".equals(System.getenv(ENV_TEST_CODE));
		PeerConfig cfg = (PeerConfig) config.get(0);
		reservationService = createReservationService();
		if (!test) {
			this.peer = new QoSMulticastPeer(determineSignallingAddress(cfg), determineMasterAddress(cfg), (Inet4Address) cfg.getInterfaceAddress(), new QoSInformation(),
					reservationService);
			this.testPeer = null;
		} else {

			this.testPeer = new EUQoSMulticastPeer(determineSignallingAddress(cfg), new InetSocketAddress(InetAddress.getLocalHost(), 3000),
					new InetSocketAddress[] { determineMasterAddress(cfg) }, getPeerID(), new QoSInformation(), reservationService);
			this.peer = null;
		}
	}

	private QoSReservationService createReservationService() {
		if (isTrue(ENV_USE_EUQOS)) {

			QCMComponent component = new QCMComponent(getPeerID(), getEnv(ENV_QCM_PASSWORD, DEFAULT_QCM_PASSWORD));
//			if (isTrue(ENV_SHOW_QCM_CONSOLE)) {
//				JFrame frame = new JFrame(); 
//
//				BQCMControlPanel controlPanel = QCM.getBQCMControlPanel();
//				if (controlPanel != null) {
//					frame.getContentPane().add(controlPanel);
//				} else {
//					System.out.println("!!!! QCM Control Panel is null");
//				}
//				frame.pack();
//				frame.setVisible(true);
//				try {
//					frame.setTitle("QCM Frame for " + InetAddress.getLocalHost());
//				} catch (UnknownHostException e) {
//					throw new RuntimeException(e);
//				}
//			}
			return component;
		} else {
			return new DummyQosReservationService();
		}

	}

	private String getPeerID() {
		return getEnv(ENV_QCM_USERNAME, DEFAULT_QCM_USERNAME);
	}

	private static boolean isTrue(String variableName) {
		String val = System.getenv(variableName);
		return Boolean.parseBoolean(val);
	}

	private static String getEnv(String name, String def) {
		String val = System.getenv(name);
		if (val == null) {
			return def;
		} else {
			return val;
		}

	}

	private InetSocketAddress determineSignallingAddress(PeerConfig cfg) {
		InetSocketAddress ret = cfg.getSignallingBindAddress();
		if (ret.getAddress() == null || ret.getAddress().isAnyLocalAddress()) {
//			try {
//				ret = new InetSocketAddress(InetAddress.getLocalHost(), ret.getPort());
//			} catch (UnknownHostException e) {
//				throw new RuntimeException(e);
//			}
		}
		return overrideConfig(ret, System.getenv(ENV_BIND_ADDRESS));
	}

	// private String determinePeerId() {
	// String ret=System.getenv(ENV_PEER_ID);
	// if (ret == null) {
	// ret="PEER_ID_NOT_SET";
	// }
	// return ret;
	// }

	private InetSocketAddress determineMasterAddress(PeerConfig cfg) {

		InetSocketAddress ret = cfg.getMasterNodeAddress();

		return overrideConfig(ret, System.getenv(ENV_MASTER_NODE));
	}

	// private QoSInformation createQoSInfo() {
	// QoSInformation info=new QoSInformation();
	// String infoEnv=System.getenv(ENV_QOS_GROUPS);
	// if (infoEnv != null) {
	// for (String reqString : infoEnv.split("\\s+")) {
	// String vals[]=reqString.split("=");
	// if (vals.length != 2) {
	// throw new RuntimeException("malformated requirement "+reqString);
	// }
	// InetAddress group;
	// try {
	// group = InetAddress.getByName(vals[0]);
	// } catch (UnknownHostException e) {
	// throw new RuntimeException(e);
	// }
	// QoSRequirement req=reqMapping.get(vals[1]);
	// info.addRequirement(group, req);
	// }
	// }
	// return info;
	// }

	private InetSocketAddress overrideConfig(InetSocketAddress configValue, String envName) {
		if (envName != null) {
			StringTokenizer st = new StringTokenizer(envName, "/");
			if (st.countTokens() != 2) {
				return configValue;
			}
			String host = st.nextToken();
			String portString = st.nextToken();
			int port = Integer.parseInt(portString);
			if (host.length() == 0) {
				configValue = new InetSocketAddress(port);
			} else {
				configValue = new InetSocketAddress(host, port);
			}
		}

		return configValue;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.avalon.framework.activity.Startable#start()
	 */
	public void start() throws IOException {
		if (peer != null) {
			peer.start();
			System.out.println("old peer started");
		}
		if (testPeer != null)
			testPeer.start();
		System.out.println("peer started");

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.avalon.framework.activity.Startable#stop()
	 */

	public void registryDidShutdown() {
		try {
			if (peer != null)
				peer.stop();
			if (testPeer != null)
				testPeer.stop();
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("router stopped");
		if (reservationService instanceof QCMComponent) {
			((QCMComponent) reservationService).stop();
		}
	}

	public MulticastRoutingTable getMulitcastRoutingTable() {
		return peer == null ? testPeer.getMulticastRoutingTable() : peer.getMulticastRoutingTable();
	}

	public void changeQoSReservation(InetAddress group, QoSRequirement req) {
		if (testPeer != null)
			testPeer.changeQoSReservation(group, req);
		else {
			peer.changeQoSReservation(group, req);
		}

	}

	private class DummyQosReservationService implements QoSReservationService {

		public ReservedResources reserveResources(final InetSocketAddress from, final InetSocketAddress to, final QoSRequirement reqirement) throws QosReservationException {
			System.out.println("!!! reserved link " + from + "-> " + to + " with qos: " + reqirement);
			return new ReservedResources() {
				public void releaseResources() {
					System.out.println("!!! released link " + from + " -> " + to + " with qos: " + reqirement);
				}
			};
		}

	}

	public QoSRequirement getQosReservation(InetAddress group) {
		if (testPeer != null)
//			testPeer.changeQoSReservation(group);
			return new QoSRequirement(0,0,0);
		else {
			return peer.getQosReservation(group);
		}
	}

}