#include <stdio.h>
#include "tuntap.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <pcap.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <net/if.h>
#include <net/route.h>
// #include <linux/if_tun.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
/* According to POSIX 1003.1-2001 */
#include <sys/select.h>
                                                                                
/* According to earlier standards */
#include <sys/time.h>
#include <unistd.h>


//char errbuf[PCAP_ERRBUF_SIZE];
                                                                                


void throwTunTapException(JNIEnv *env, char* errbuf) {
	jclass ioExceptionClass=(*env)->FindClass(env,"java/io/IOException");
	
	if (ioExceptionClass) {
		(*env)->ThrowNew(env,ioExceptionClass,errbuf);
	} 
	
}

void copyInetAddress(JNIEnv *env, char *to, jbyteArray array) {
	jbyte* bytes=(*env)->GetByteArrayElements(env,array,NULL);
  	memcpy(to,bytes,4);
  	(*env)->ReleaseByteArrayElements(env,array,bytes,JNI_ABORT);
}


// -------------------------------------------------------------------------------------------------------------------------------------------


/*
 * Class:     ch_unibe_iam_mcast_iface_linux_TapInterface
 * Method:    openNewInterface
 * Signature: ()I
 */
jint JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_openNewInterface
  (JNIEnv *env, jclass class, jbyteArray address) { 
     struct ifaliasreq ifalias;
     
     int fd, err;
     int socketfd;
      
      fd = open("/dev/tap0", O_RDWR);
      if (fd < 0) {
      	throwTunTapException(env,"could not open tap device");
         return err;
      } 
system("/sbin/ifconfig tap0 10.2.3.4 netmask 255.255.255.255 up");  
system("/sbin/route add -net 224.0.0.0/5 -interface tap0");
sleep(5);
fprintf(stderr,"opened!\n");
 	return fd;
} 


/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    readPacket
 * Signature: (I[B)I
 */
JNIEXPORT jint JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_readPacket
  (JNIEnv *env, jclass class, jint descriptor, jbyteArray bufferArray) {
  	
	int retval;
	                                                                        
	
	int len=(*env)->GetArrayLength(env,bufferArray);
	int readBytes;
	char tmpBuffer[len+6];
	for(;;) {                                                                        
		/* Don’t rely on the value of tv now! */
		jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);
		readBytes=read(descriptor,bytes,len);
	//	fprintf(stderr,"read bytes %d\n",readBytes);
		//readBytes=read(descriptor,tmpBuffer,len+6);
		//memcpy(bytes, &tmpBuffer[6], readBytes-6);
		(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
		
		if (readBytes < 0) {
			throwTunTapException(env,"error reading the packet");
			return -1;
		} else if (readBytes) {
			return readBytes;
		} 
	   
	} 
}



/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    sendPacket
 * Signature: (I[BI)V
 */
JNIEXPORT void JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_sendPacket
  (JNIEnv *env, jclass class, jint descriptor, jbyteArray bufferArray, jint length) {
  	jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);
  	int writtenBytes=write(descriptor,bytes,length);
  	(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
  	if (writtenBytes == -1) {
  		throwTunTapException(env,"error writing the packet");
  	}
  	
}

/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    closeInterface
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_closeInterface
  (JNIEnv *env, jclass class, jint descriptor) {
  	
  	int ret=close(descriptor);
  	if (ret == -1) {
  		throwTunTapException(env,"error writing closing the tap");
  	}
}





  


