#include <stdio.h>
#include <strings.h>
#include "tuntap.h"
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <net/if.h>
#include <net/route.h>
#include <linux/if_tun.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
/* According to POSIX 1003.1-2001 */
#include <sys/select.h>
                                                                                
/* According to earlier standards */
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>



                                                                                


void throwTunTapException(JNIEnv *env, char* errbuf) {
	jclass ioExceptionClass=(*env)->FindClass(env,"java/io/IOException");
	
	if (ioExceptionClass) {
		(*env)->ThrowNew(env,ioExceptionClass,errbuf);
	} 
	
}

void copyInetAddress(JNIEnv *env, char *to, jbyteArray array) {
	jbyte* bytes=(*env)->GetByteArrayElements(env,array,NULL);
  	memcpy(to,bytes,4);
  	(*env)->ReleaseByteArrayElements(env,array,bytes,JNI_ABORT);
}



/*
 * Class:     ch_unibe_iam_mcast_iface_linux_TapInterface
 * Method:    openNewInterface
 * Signature: ()I
 */
jint JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_openNewInterface
  (JNIEnv *env, jclass class, jbyteArray address) { 
     struct ifreq ifr;
     int fd, err;
     int socketfd;
                                                                                                                              
      if( (fd = open("/dev/net/tun", O_RDWR )) < 0 ) {
      	throwTunTapException(env,"could not open /dev/net/tun");
      	return -1;
      }
                                                                                                                              
      memset(&ifr, 0, sizeof(ifr));
                                                                                                                              
      /* Flags: IFF_TUN   - TUN device (no Ethernet headers)
       *        IFF_TAP   - TAP device
       *
       *        IFF_NO_PI - Do not provide packet information
       */
      
      
      

        ifr.ifr_flags = IFF_TAP | IFF_NO_PI;
      
      
     
                                                                                                                 
      if (ioctl(fd, TUNSETIFF, (char *) &ifr) < 0){
         close(fd);
         throwTunTapException(env,"could not allocate new tap device");
         return err;
      }
      
      //bzero(&ifr, sizeof(ifr));
      socketfd=socket(PF_INET,SOCK_DGRAM,IPPROTO_IP);
      if (socketfd < 0) {
      	 close(fd);
      	 throwTunTapException(env,"could not open dgram socket");
         return err;
      }
      
      struct sockaddr_in *sin=(struct sockaddr_in *)&ifr.ifr_addr;
     /* struct sockaddr_in *sin= (struct sockaddr_in *)&ifr.ifr_addr;
      
      //ifr.ifr_flags = 0;
      //ifr.ifr_addr.sa_family=AF_INET;
	    //  *((ifr.ifr_addr.sa_data))=htonl(0x0a000001); */
	    
	    sin->sin_family=AF_INET;
	    copyInetAddress(env,(void *)&sin->sin_addr.s_addr,address);
	 
      err=ioctl(socketfd, SIOCSIFADDR, &ifr);
      if (err != 0) {
      	/*perror("set ip address");*/
      	 close(fd);
      	 close(socketfd);
      	 throwTunTapException(env,"could not set an ip address");
         return err;
      }
 
    
     	sin->sin_family=AF_INET;
	    sin->sin_addr.s_addr=htonl(0xffffffff);
	  
      err=ioctl(socketfd, SIOCSIFNETMASK, &ifr);
      if (err != 0) {
      	/*perror("set ip address");*/
      	 close(fd);
      	 close(socketfd);
      	 throwTunTapException(env,"could not set an ip netmask");
         return err;
      }     
      
      bzero(&ifr.ifr_addr, sizeof(ifr.ifr_addr));
       
      ifr.ifr_flags = IFF_UP | IFF_RUNNING | IFF_MULTICAST;
      
//     ((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr.s_addr=htonl(0x0a000001);
//      ifr.ifr_addr.sa_family=AF_INET;
//      *(ifr.ifr_addr.sa_data)=htonl(0xffffffff);
      err=ioctl(socketfd, SIOCSIFFLAGS, &ifr);
      if (err != 0) {
      	 close(fd);
      	 close(socketfd);
      	 throwTunTapException(env,"could not set interface flags");
         return err;
      }
      
      
      
      
      
      struct rtentry newRoute;
      bzero(&newRoute, sizeof(newRoute));
      
      struct sockaddr_in *routeDestination= (struct sockaddr_in *)&newRoute.rt_dst;
      struct sockaddr_in *routeNetmask= (struct sockaddr_in *)&newRoute.rt_genmask;
      struct sockaddr_in *gateway= (struct sockaddr_in *)&newRoute.rt_gateway;
      newRoute.rt_dev=ifr.ifr_name;
      
      routeDestination->sin_family=AF_INET;
      routeDestination->sin_addr.s_addr=htonl(0xe0000000); /* INADDR_UNSPEC_GROUP; */
      
      routeNetmask->sin_family=AF_INET;
      routeNetmask->sin_addr.s_addr=htonl(0xe0000000);
      
       gateway->sin_family=AF_INET;
      /*routeNetmask->sin_addr.s_addr=INADDR_UNSPEC_GROUP;*/
      
      newRoute.rt_flags=RTF_UP;
      
      err=ioctl(socketfd, SIOCADDRT, &newRoute);
      if (err != 0) {
      	perror("add route");
      	 close(fd);
      	 close(socketfd);
      	 throwTunTapException(env,"could not add route");
         return err;
      }
      
      
      /*strcpy(dev, ifr.ifr_name);*/
      return fd;

}
  

/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    readPacket
 * Signature: (I[B)I
 */
JNIEXPORT jint JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_readPacket
  (JNIEnv *env, jclass class, jint descriptor, jbyteArray bufferArray) {
  	
	fd_set rfds;
	struct timeval tv;
	/*int retval;*/
	                                                                        
	/* Watch stdin (fd 0) to see when it has input. */
	FD_ZERO(&rfds);
	FD_SET(0, &rfds);
	/* Wait up to five seconds. */
	tv.tv_sec = 1;
	tv.tv_usec = 0;
	
	
	int len=(*env)->GetArrayLength(env,bufferArray);
	int readBytes;
	/*printf("waiting\n");*/
	
	jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);
	readBytes=read(descriptor,bytes,len);
	(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
	
	if (readBytes < 0) {
		throwTunTapException(env,"error reading the packet");
		return -1;
	} else if (readBytes) {
		return readBytes;
	} else {
		return readBytes;
	}
		
	/*	
//	for(;;) {                                                                        
//		retval = select(descriptor, &rfds, NULL, NULL, NULL);
//		
//		if (retval==0) {
//			// timeout, check the interrupted
//			
//			jclass packetClass=(*env)->FindClass(env,"java/lang/Thread");
//		  	
//		  	jmethodID interrruptedMethod=(*env)->GetMethodID(env, packetClass, "interrrupted", "()B");
//		  	
//		  	printf("timeout class %x method %x\n",packetClass,interrruptedMethod);
//			
//			jboolean ret=(*env)->CallBooleanMethod(env,0,interrruptedMethod);
//			
//			if (ret) {
//				return 0;
//			}
//		}
//		
//		printf("recv\n");
//			
//		// Don’t rely on the value of tv now!
//		jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);
//		readBytes=read(descriptor,bytes,len);
//		(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
//		
//		if (readBytes < 0) {
//			throwTunTapException(env,"error reading the packet");
//			return -1;
//		} else if (readBytes) {
//			return readBytes;
//		} 
	   
//	} */
  	
  	
  	
  	

}

/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    sendPacket
 * Signature: (I[BI)V
 */
JNIEXPORT void JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_sendPacket
  (JNIEnv *env, jclass class, jint descriptor, jbyteArray bufferArray, jint length) {
  	jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);
  	int writtenBytes=write(descriptor,bytes,length);
  	(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
  	if (writtenBytes == -1) {
  		throwTunTapException(env,"error writing the packet");
  	}
  	
}

/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    closeInterface
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_closeInterface
  (JNIEnv *env, jclass class, jint descriptor) {
  	
  	int ret=close(descriptor);
  	if (ret == -1) {
  		perror("tap close");
  		throwTunTapException(env,"error while closing the tap interface");
  	}
}



  


