#include <stdio.h>
#include <strings.h>
#include "tuntap.h"  
#include "wintt.h" 
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <unistd.h>


/* WinTap Options*/
#include <windows.h>
#include <ddk/ntapi.h> 
#include <ddk/winddk.h>
#include <ddk/ntddk.h>

                                                                                




void throwTunTapException(JNIEnv *env, char* errbuf) {
	jclass ioExceptionClass=(*env)->FindClass(env,"java/io/IOException");
	
	if (ioExceptionClass) 
	{
		(*env)->ThrowNew(env,ioExceptionClass,errbuf);
	} 	
}

void copyInetAddress(JNIEnv *env, char *to, jbyteArray array) {
	jbyte* bytes=(*env)->GetByteArrayElements(env,array,NULL);
  	memcpy(to,bytes,4);
  	(*env)->ReleaseByteArrayElements(env,array,bytes,JNI_ABORT);
}


/*
 * Class:     ch_unibe_iam_mcast_iface_linux_TapInterface
 * Method:    openNewInterface
 * Signature: ()I
 */
jint JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_openNewInterface
  (JNIEnv *env, jclass class, jbyteArray address) {
     
     jint handle;   
     if(tap_win32_open(&handle, "tap-bridge") != 0){
     	return -1;
     }
     return handle;   
}
  

/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    readPacket
 * Signature: (I[B)I
 */
JNIEXPORT jint JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_readPacket
  (JNIEnv *env, jclass class, jint descriptor, jbyteArray bufferArray) {

	int len=(*env)->GetArrayLength(env,bufferArray);
	int readBytes;
	char *data;
	
	jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);	
	readBytes=tap_win32_read(descriptor,&data,len);
	
	if (readBytes > 0) { 
			memcpy(bytes,data,readBytes);
			tap_win32_free_buffer(descriptor,data);
	}
	(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
	
	if (readBytes < 0) 
	{
		throwTunTapException(env,"error reading the packet");
		return -1;
	} else if (readBytes) {
		return readBytes;
	} else {
		return readBytes;
	}
		
}

/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    sendPacket
 * Signature: (I[BI)V
 */
JNIEXPORT void JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_sendPacket
  (JNIEnv *env, jclass class, jint descriptor, jbyteArray bufferArray, jint length) {
  	
  	jbyte* bytes=(*env)->GetByteArrayElements(env,bufferArray,NULL);
  	
  	
  	int writtenBytes=tap_win32_write(descriptor,bytes,length);
  	(*env)->ReleaseByteArrayElements(env,bufferArray,bytes,0);
  	
  	if (writtenBytes == -1) 
  	{
  		throwTunTapException(env,"error writing the packet");
  		return -1;
  	}
  	
  	return writtenBytes;	
}



/*
 * Class:     ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface
 * Method:    closeInterface
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_ch_unibe_iam_mcast_iface_linux_tuntap_TapInterface_closeInterface
  (JNIEnv *env, jclass class, jint descriptor) 
{ 	
  	int res = tap_win32_close((HANDLE)descriptor);
  	
  	if (res == 0) 
  	{
  		perror("tap close");
  		throwTunTapException(env,"error while closing the tap interface");
  	} 	
}
