package ch.unibe.iam.mcast.core;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.List;

public interface MulticastCore {
    
    public MulticastRoutingTable getRoutingTable();
    
    public List getCurrentPeerConnections(); // List of PeerConnection objects
    
    public LocalNetworkInterface openVirtualInterface(InetAddress interfaceAddress) throws IOException;
    
    public void connectToPeer(InetSocketAddress remotePeer,ConnectCallback callback);
    
    public int getServerPort();
    
    public void addConnectionStatusEventListener(ConnectionStatusEventListener listener);
    public void removeConnectionStatusEventListener(ConnectionStatusEventListener listener);
    

}
