package ch.unibe.iam.mcast.core;

import java.net.InetAddress;
import java.util.Map;
import java.util.Set;

public interface MulticastRoutingTable {
    
    public static final int PRIORITY_LOW=30;
    public static final int PRIORITY_MEDIUM=20;
    public static final int PRIORITY_HIGH=10;
    
    public void addRoute(InetAddress multicastGroup, MulticastRoutingDestination destination, int priority);
    public void removeRoute(InetAddress multicastGroup, MulticastRoutingDestination destination);
    public void removeDestination(MulticastRoutingDestination destination);
    public boolean hasRoutesForGroup(InetAddress multicastGroup);
    public boolean hasRoute(InetAddress group, MulticastRoutingDestination destination);
    public Map<InetAddress,Set<MulticastRoutingTableEntry>> getRoutes(); // InetAddress -> Set of destinations
    
    public int getMaxPriority(InetAddress group);
    
    
    public void addMulticastRoutingTableListener(MulticastRoutingTableListener listener);
    public void removeMulticastRoutingTableListener(MulticastRoutingTableListener listener);
    public int getMaxPriority(InetAddress group, MulticastRoutingDestination destination);
   

}
