package ch.unibe.iam.mcast.core;


public class MulticastRoutingTableEntry {

    private final MulticastRoutingDestination destination;
    
    private final int priority;

    public MulticastRoutingTableEntry(MulticastRoutingDestination destination, int priority) {
        

        if (destination == null) {
            throw new IllegalArgumentException("destination should not be null");
        }
        this.destination = destination;
        
        this.priority=priority;
        
    }

    public MulticastRoutingDestination getDestination() {
        return destination;
    }

    

    public String toString() {
        return destination+"/"+priority;
    }

    public int hashCode() {
        return destination.hashCode() ^ priority;

    }

    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof MulticastRoutingTableEntry)) {
            return false;
        }
        MulticastRoutingTableEntry other = (MulticastRoutingTableEntry) o;
        return other.destination.equals(destination) && other.priority==priority;
    }

    public int getPriority() {
        return priority;
    }

}
