package ch.unibe.iam.mcast.core.java;

import java.net.Inet4Address;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

public class IPV4AddressCache {
	
	private final List<CacheEntry> entries=new ArrayList<CacheEntry>();
	
	public Inet4Address lookup(int address) {
		
		// TODO use divide & conquer search
		for (int i=0; i<entries.size();i++) {
			CacheEntry entry=entries.get(i);
			if (entry.getAddress() == address) {
				return entry.getValue();
			} 
		}
		
		CacheEntry entry=new CacheEntry(address);
		entries.add(entry);
		return entry.getValue();
	}
	
	
	private class CacheEntry {
		private final int address;
		private final Inet4Address value;
		
		public CacheEntry(int address) {
			this.address=address;
			try {
				this.value=(Inet4Address) Inet4Address.getByAddress(new byte[]{(byte) ((address&0xff000000)>>24),(byte) ((address&0xff0000)>>16),(byte) ((address&0xff00)>>8),(byte) (address&0xff)});
			} catch (UnknownHostException e) {
				throw new RuntimeException(e);
			}
			
		}

		public int getAddress() {
			return address;
		}

		public Inet4Address getValue() {
			return value;
		}
		
		
		
	}
	

}
