/*
 * Created on Oct 18, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.iface.linux.pcap;

import java.nio.ByteBuffer;
import java.util.Date;

import ch.unibe.iam.mcast.net.ip.IPV4Packet;
import ch.unibe.iam.mcast.net.ip.MalformedPacketException;
import ch.unibe.iam.mcast.net.ip.util.ByteBufferUtil;

/**
 * @author root
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class CapturedPacket {
	private final long timestamp;

	private final int caplen;

	private final int len;

	private final int datalinkType;

	private final byte[] data;

	private static final int DLT_NULL = 0; /* no link-layer encapsulation */

	private static final int DLT_EN10MB = 1; /* Ethernet (10Mb) */

	private static final int DLT_EN3MB = 2; /* Experimental Ethernet (3Mb) */

	private static final int DLT_AX25 = 3; /* Amateur Radio AX.25 */

	private static final int DLT_PRONET = 4; /* Proteon ProNET Token Ring */

	private static final int DLT_CHAOS = 5; /* Chaos */

	private static final int DLT_IEEE802 = 6; /* IEEE 802 Networks */

	private static final int DLT_ARCNET = 7; /*
											  * ARCNET, with BSD-style header
											  */

	private static final int DLT_SLIP = 8; /* Serial Line IP */

	private static final int DLT_PPP = 9; /* Point-to-point Protocol */

	private static final int DLT_FDDI = 10; /* FDDI */

	private static int headerLength(int dltType) {
		switch (dltType) {
		case DLT_NULL:
			return 0;
		case DLT_EN10MB:
			return 14;
		default:
			return 16;
		}
	}

	public CapturedPacket(long timestamp, int caplen, int len,
			int datalinkType, byte[] data) {
		this.timestamp = timestamp;
		this.caplen = caplen;
		this.len = len;
		this.datalinkType = datalinkType;
		this.data = data;
	}

	/**
	 * @return Returns the caplen.
	 */
	public int getCaplen() {
		return caplen;
	}

	/**
	 * @return Returns the data.
	 */
	public byte[] getData() {
		return data;
	}

	/**
	 * @return Returns the len.
	 */
	public int getLen() {
		return len;
	}

	/**
	 * @return Returns the timestamp.
	 */
	public long getTimestamp() {
		return timestamp;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "capturedPacket(" + new Date(timestamp) + ", "
				+ ByteBufferUtil.byteBufferToString(ByteBuffer.wrap(data))
				+ ")";
	}
	
	public IPV4Packet getIPPacket() throws MalformedPacketException {
		ByteBuffer buffer=ByteBuffer.wrap(data);
		buffer.position(headerLength(datalinkType));
		//ByteBufferUtil.dumpByteBuffer(buffer);
		return IPV4Packet.createIPV4Packet(buffer);
	}

}