/*
 * Created on Dec 3, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.iface.linux.tuntap;

import java.io.IOException;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ethernet.EthernetAddress;
import ch.unibe.iam.mcast.net.ethernet.EthernetPacket;
import ch.unibe.iam.mcast.net.ip.udp.UDPPacket;
import ch.unibe.iam.mcast.net.ip.util.ByteBufferUtil;

/**
 * @author root
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TapInterface {
    
    private final int descriptor;
    private boolean closed=false;
    
    static {
    	System.out.println("java.library.path: "+System.getProperty("java.library.path"));
        System.loadLibrary("tuntap");
    }

    /**
     * 
     */
    private TapInterface(int descriptor) {
        this.descriptor=descriptor;
    }
    
    public int readPacket(byte[] buffer) throws IOException {
        if (closed) {
            throw new IOException("tap socket closed");
        }
        int bytesRead=readPacket(descriptor,buffer);
        if (bytesRead == 0) {
            closed=true;
        }
        return bytesRead;
    }
    
    public void writePacket(byte[] buffer, int length) throws IOException {
        //System.out.println("writing bytes: "+length);
         sendPacket(descriptor, buffer, buffer.length);
    }
    
    public void close() throws IOException {
        
        System.out.println("++++++++ closing tap interface");
        closeInterface(descriptor);
        System.out.println("---------- closed tap interface ");
    }
    
    
    
    private native static int openNewInterface(byte[] interfaceAddress);
    
    private native static int readPacket(int descriptor, byte[] buffer) throws IOException;
    
    private native static void sendPacket(int descriptor, byte[] buffer, int length) throws IOException;  
    
    private native static void closeInterface(int descriptor) throws IOException;
    
    public static TapInterface openNewTapInterface(Inet4Address interfaceAddress) {
        return new TapInterface(openNewInterface(interfaceAddress.getAddress()));
    }
    
    private static EthernetAddress createMulticastAddress(Inet4Address address) {
        //01:00:5e 
        byte[] inet=address.getAddress();
        byte third=(byte)(inet[1] &0x7f);
        return new EthernetAddress(new byte[]{0x01,0x00,0x5e,third,inet[2],inet[3]});
    }
    
    public static void main(String argv[]) throws Exception {
        Inet4Address ifaceAddress=(Inet4Address) InetAddress.getByAddress(new byte[]{1,2,3,3});
        TapInterface ti=openNewTapInterface(ifaceAddress);
        byte[] buffer=new byte[64*1024];
        ByteBuffer bb=ByteBuffer.wrap(buffer);
        EthernetAddress myEthernetAddress=new EthernetAddress(new byte[]{1,2,3,4,5,6});
        for (;;) {
            int read=ti.readPacket(buffer);
            /*ByteBuffer tmpWrap = ByteBuffer.wrap(buffer);
            tmpWrap.limit(read);
            ByteBufferUtil.dumpByteBuffer(tmpWrap);
            System.out.println(read);*/
            bb.position(0);
            bb.limit(read);
//            int header=bb.getInt();
//            System.out.println("header: "+header);
            EthernetPacket packet=EthernetPacket.createPacket(bb);
            System.out.println("received packet: "+packet);
            UDPPacket udpPacket=new UDPPacket((short)9875,(short)9875,"Helloo113".getBytes());
            udpPacket.setTimeToLive((byte)1);
            udpPacket.setFlags((byte)2);
            //  239.255.255.254
            Inet4Address destination=(Inet4Address) InetAddress.getByAddress(new byte[] {(byte)239,(byte)255,(byte)255,(byte)254});
            Inet4Address source=(Inet4Address) InetAddress.getByAddress(new byte[] {(byte)1,(byte)2,(byte)3,(byte)4}); 
            udpPacket.setSourceAddress(source);
            udpPacket.setDestinationAddress(destination);
            
            
            EthernetPacket sendPacket=new EthernetPacket(createMulticastAddress(destination), new EthernetAddress(new byte[]{1,2,3,4,5,6}), udpPacket);
            bb.clear();
            sendPacket.serializePacket(bb);
            
            ti.writePacket(buffer,bb.position());
            
//            Packet transported=packet.getTransportedPacket();
//            
//            if (transported instanceof EthernetIPV4ARPPacket) {
//                EthernetIPV4ARPPacket ethArp=(EthernetIPV4ARPPacket) transported;
//                if (ethArp.getOperation()
//            }
           //ByteBufferUtil.dumpByteBuffer(bb);
        }
    }

}
