/*
 * Created on Dec 3, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.arp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.Packet;
import ch.unibe.iam.mcast.net.ethernet.EthernetConstants;

/**
 * @author root
 * 
 * TODO To change the template for this generated type comment go to Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class ARPPacket implements Packet {

    //    private final short hardwareAddressType;
    //    private final short protocolAddressType;
    //    
    //    private final short operation;
    //    
    //    private byte[] senderHardwareAddress;
    //    private byte[] receiverHardwareAddress;

    public static ARPPacket parseARPPacket(ByteBuffer buffer) {
        short hardwareAddressType = buffer.getShort();
        short protocolAddressType = buffer.getShort();
        int hardwareAddressLength = buffer.get() & 0xffff;
        int protocolAddressLength = buffer.get() & 0xffff;

        System.out.println("hwadrt: " + hardwareAddressType + " pradrt: " + protocolAddressType + " hwaddrl " + hardwareAddressLength + " praddrl " + protocolAddressLength);
        if (hardwareAddressType == EthernetConstants.ETH_P_802_3 && protocolAddressType == EthernetConstants.ETH_P_IP && hardwareAddressLength == EthernetConstants.ETHERNET_ADDRESS_LENGTH
                && protocolAddressLength == 4) {
            return new EthernetIPV4ARPPacket(buffer);

        }
        return null;
    }

    public void serializePacket(ByteBuffer buffer) {
        buffer.putShort(getHardwareAddressType());
        buffer.putShort(getProtocolAddressType());
        buffer.put(getHardwareAddressLength());
        buffer.put(getProtocolAddressLength());
        buffer.putShort(getOperation());
        serializeSenderHardwareAddress(buffer);
        serializeSenderProtocolAddress(buffer);
        serializeDestinationHardwareAddress(buffer);
        serializeDestinationProtocolAddress(buffer);
    }

    public int getPacketLength() {

        return getHardwareAddressLength() & 0xff * 2 + getProtocolAddressLength() & 0xff * 2 + 2 + 2 + 1 + 1 + 2;
    }

    protected abstract short getHardwareAddressType();

    protected abstract short getProtocolAddressType();

    protected abstract byte getHardwareAddressLength();

    protected abstract byte getProtocolAddressLength();

    protected abstract void serializeSenderHardwareAddress(ByteBuffer buffer);

    protected abstract void serializeSenderProtocolAddress(ByteBuffer buffer);

    protected abstract void serializeDestinationHardwareAddress(ByteBuffer buffer);

    protected abstract void serializeDestinationProtocolAddress(ByteBuffer buffer);

    protected abstract short getOperation();

}