/*
 * Created on Dec 3, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.arp;

import java.net.Inet4Address;
import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ethernet.EthernetAddress;
import ch.unibe.iam.mcast.net.ethernet.EthernetConstants;
import ch.unibe.iam.mcast.net.ip.util.IPV4AddressUtil;

/**
 * @author root
 * 
 * TODO To change the template for this generated type comment go to Window - Preferences - Java - Code Style - Code Templates
 */
public class EthernetIPV4ARPPacket extends ARPPacket {

    private final short operation;

    private final EthernetAddress senderHardwareAddress;

    private final Inet4Address senderProtocolAddress;

    private final EthernetAddress destinationHardwareAddress;

    private final Inet4Address destinationProtocolAddress;

    /**
     *  
     */
    public EthernetIPV4ARPPacket(ByteBuffer arpBuffer) {
        if (arpBuffer.remaining() < (2 + EthernetConstants.ETHERNET_ADDRESS_LENGTH * 2 + 4 * 2)) {
            throw new IllegalArgumentException("arp packet too short for ethernet ipv4 ARP");
        }
        this.operation = arpBuffer.getShort();
        this.senderHardwareAddress = new EthernetAddress(arpBuffer);
        this.senderProtocolAddress = IPV4AddressUtil.readAddress(arpBuffer);
        this.destinationHardwareAddress = new EthernetAddress(arpBuffer);
        this.destinationProtocolAddress = IPV4AddressUtil.readAddress(arpBuffer);
    }

    public EthernetAddress getDestinationHardwareAddress() {
        return destinationHardwareAddress;
    }

    public Inet4Address getDestinationProtocolAddress() {
        return destinationProtocolAddress;
    }

    public short getOperation() {
        return operation;
    }

    public EthernetAddress getSenderHardwareAddress() {
        return senderHardwareAddress;
    }

    public Inet4Address getSenderProtocolAddress() {
        return senderProtocolAddress;
    }

    public String toString() {
        return "ARP(802.3<->IPV4)(senderhw: " + senderHardwareAddress + ", senderProto: " + senderProtocolAddress + ", desthw: " + destinationHardwareAddress + " destproto: "
                + destinationProtocolAddress + ")";
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#getHardwareAddressType()
     */
    protected short getHardwareAddressType() {
        // TODO Auto-generated method stub
        return EthernetConstants.ETH_P_802_3;
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#getProtocolAddressType()
     */
    protected short getProtocolAddressType() {
        return EthernetConstants.ETH_P_IP;
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#getHardwareAddressLength()
     */
    protected byte getHardwareAddressLength() {
        
        return EthernetConstants.ETHERNET_ADDRESS_LENGTH;
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#getProtocolAddressLength()
     */
    protected byte getProtocolAddressLength() {
        return 4;
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#serializeSenderHardwareAddress(java.nio.ByteBuffer)
     */
    protected void serializeSenderHardwareAddress(ByteBuffer buffer) {
        senderHardwareAddress.serializeAddress(buffer);
        
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#serializeSenderProtocolAddress(java.nio.ByteBuffer)
     */
    protected void serializeSenderProtocolAddress(ByteBuffer buffer) {
        buffer.put(senderProtocolAddress.getAddress());
        
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#serializeDestinationHardwareAddress(java.nio.ByteBuffer)
     */
    protected void serializeDestinationHardwareAddress(ByteBuffer buffer) {
        destinationHardwareAddress.serializeAddress(buffer);
        
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.arp.ARPPacket#serializeDestinationProtocolAddress(java.nio.ByteBuffer)
     */
    protected void serializeDestinationProtocolAddress(ByteBuffer buffer) {
        buffer.put(destinationProtocolAddress.getAddress());      
    }


}