/*
 * Created on Dec 3, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ethernet;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.Address;
import ch.unibe.iam.mcast.net.ip.util.ByteUtil;
import ch.unibe.iam.mcast.net.ip.util.HashUtil;

/**
 * @author root
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class EthernetAddress implements Address {

    private final byte[] addressBytes = new byte[EthernetConstants.ETHERNET_ADDRESS_LENGTH];

    private final int hashCode;

    /**
     *  
     */
    public EthernetAddress(byte[] address) {
        if (address.length != EthernetConstants.ETHERNET_ADDRESS_LENGTH) {
            throw new IllegalArgumentException("ethernet address must have " + EthernetConstants.ETHERNET_ADDRESS_LENGTH + " bytes");
        }
        System.arraycopy(address, 0, addressBytes, 0, EthernetConstants.ETHERNET_ADDRESS_LENGTH);
        this.hashCode = computeChecksum(addressBytes);

    }
    
    public EthernetAddress(ByteBuffer buffer) {
        if (buffer.remaining() < EthernetConstants.ETHERNET_ADDRESS_LENGTH) {
            throw new IllegalArgumentException("buffer must have at least "+EthernetConstants.ETHERNET_ADDRESS_LENGTH+" bytes remaining");
        }
        buffer.get(addressBytes);
        this.hashCode=computeChecksum(addressBytes);
    }

    /**
     *  
     */
    private static int computeChecksum(byte[] addressBytes) {
        int hashTemp = addressBytes[0] & 0xff;
        hashTemp = hashTemp << 8 & addressBytes[1] & 0xff;
        hashTemp = hashTemp << 8 & addressBytes[2] & 0xff;
        hashTemp = hashTemp << 8 & addressBytes[3] & 0xff;
        return hashTemp;
    }

    public boolean equals(Object obj) {
        if (!(obj instanceof EthernetAddress)) {
            return false;
        }
        EthernetAddress other = (EthernetAddress) obj;
        return HashUtil.areEqual(this.addressBytes, other.addressBytes);
    }

    public int hashCode() {
        return super.hashCode();
    }

    public String toString() {
        StringBuffer stringRepresentation = new StringBuffer();
        for (int i = 0; i < EthernetConstants.ETHERNET_ADDRESS_LENGTH; i++) {
            stringRepresentation.append(ByteUtil.toHex(addressBytes[i]));
            if (i + 1 < EthernetConstants.ETHERNET_ADDRESS_LENGTH) {
                stringRepresentation.append(":");
            }
        }
        return stringRepresentation.toString();
    }
    
    public void serializeAddress(ByteBuffer buffer) {
        buffer.put(addressBytes);
    }
}