/*
 * Created on Oct 19, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ip.icmp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
import ch.unibe.iam.mcast.net.ip.MalformedPacketException;

/**
 * @author root
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class AbstractEchoReplyPacket extends ICMPV4Packet {
	
	private final byte[] data;
	private final byte type;
	private final byte code;
	private final short identifier;
	private final short sequenceNumber;
	
	protected AbstractEchoReplyPacket(byte type, byte code, short identifier, short sequenceNumber, byte[] data) {
		this.type=type;
		this.code=code;
		if (data == null) {
			throw new IllegalArgumentException("data should not be null");
		}
		this.data=data;
		this.identifier=identifier;
		this.sequenceNumber=sequenceNumber;
	}
	
	protected AbstractEchoReplyPacket(byte type, byte code, IPV4PacketHeader header, ByteBuffer data) throws MalformedPacketException {
	    super(header);
	    if (data.remaining() < 8) {
	        throw new MalformedPacketException("ICMP echo/echo reply packet too short");
	    }
		this.type=data.get();
		this.code=data.get();
		this.identifier=data.getShort();
		this.sequenceNumber=data.getShort();
		this.data=new byte[data.remaining()];
		data.get(this.data);
		
	}
	
	
	

	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.icmp.ICMPV4Packet#getCode()
	 */
	protected byte getCode() {
		return code;
	}
	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.icmp.ICMPV4Packet#getIcmpDataLength()
	 */
	protected int getIcmpDataLength() {
		return 4+data.length;
	}
	
	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.icmp.ICMPV4Packet#serializeICMPData(java.nio.ByteBuffer)
	 */
	protected void serializeICMPData(ByteBuffer buffer) {
		buffer.putShort(identifier);
		buffer.putShort(sequenceNumber);
		buffer.put(data);
	}
	
	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.icmp.ICMPV4Packet#getType()
	 */
	protected byte getType() {
		return type;
	}
    /**
     * @return Returns the data.
     */
    public byte[] getData() {
        return data;
    }
    /**
     * @return Returns the identifier.
     */
    public short getIdentifier() {
        return identifier;
    }
    /**
     * @return Returns the sequenceNumber.
     */
    public short getSequenceNumber() {
        return sequenceNumber;
    }
}
