/*
 * Created on Oct 19, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ip.icmp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPV4Packet;
import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
import ch.unibe.iam.mcast.net.ip.IPProtocolConstants;
import ch.unibe.iam.mcast.net.ip.util.InternetChecksumUtil;

/**
 * @author root
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public abstract class ICMPV4Packet extends IPV4Packet {

	/**
	 * @param protocol
	 */
	public ICMPV4Packet() {
		super(IPProtocolConstants.ICMP);
	}

	/**
	 * @param header
	 */
	ICMPV4Packet(IPV4PacketHeader header) {
		super(header);

	}

	protected void serializeData(ByteBuffer buffer) {
		int startPosition=buffer.position();
		buffer.put(getType());
		buffer.put(getCode());
		int checksumPosition=buffer.position();
		buffer.putShort((short)0);
		serializeICMPData(buffer);
		int oldLimit=buffer.limit();
		buffer.limit(buffer.position());
		// TODO check if the serialization used the whole space as defined in geticmpDataLength
		short checksum=InternetChecksumUtil.computeInetChecksum(buffer);
		buffer.position(buffer.limit());
		buffer.limit(oldLimit);
		buffer.putShort(checksumPosition,checksum);
	}

	/**
	 * @param buffer
	 */
	protected abstract void serializeICMPData(ByteBuffer buffer);

	/**
	 * @return
	 */
	protected abstract byte getCode();

	/**
	 * @return
	 */
	protected abstract byte getType();

	protected final int getDataLengt() {
		return 4 + getIcmpDataLength();
	}

	/**
	 * @return
	 */
	protected abstract int getIcmpDataLength();

}