/*
 * Created on Oct 8, 2004
 *
 */
package ch.unibe.iam.mcast.net.ip.igmp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPProtocolPacketFactory;
import ch.unibe.iam.mcast.net.ip.IPV4Packet;
import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
import ch.unibe.iam.mcast.net.ip.MalformedPacketException;
import ch.unibe.iam.mcast.net.ip.UnknownIPV4Packet;

/**
 * @author dragan
 * 
 */
public class IGMPProtocolPacketFactory implements IPProtocolPacketFactory {

	public IPV4Packet createPacket(IPV4PacketHeader header, ByteBuffer dataBuffer) throws MalformedPacketException {
		// TODO check the checksum
		byte type = dataBuffer.get();
		// System.out.println("type: "+type);
		if (type == 0x11) {
			byte timeout = dataBuffer.get(dataBuffer.position());
			if (timeout == 0)
				return new IGMPV1QueryPacket(header, dataBuffer);
			else
				return new IGMPV2QueryPacket(header, dataBuffer);
		} else if (type == 0x12) {
			return new IGMPV1ReportPacket(header, dataBuffer);
		} else if (type == 0x16) {
			return new IGMPV2ReportPacket(header, dataBuffer);
		} else if (type == 0x17) {
			return new IGMPV2LeaveGroupPacket(header, dataBuffer);
		} else {
			System.out.println("unknown type " + type);
			return new UnknownIPV4Packet(header, dataBuffer);
		}
	}
}
