/*
 * Created on Oct 8, 2004
 *
 */
package ch.unibe.iam.mcast.net.ip.igmp;

import java.net.Inet4Address;
import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
//import ch.unibe.iam.mcast.ip.util.IPV4AddressUtil;

/**
 * @author dragan
 *
 */
public class IGMPV1QueryPacket extends IGMPPacket {

    // private byte maxResponseTime; // IGMPv2
    // private Inet4Address groupAddress=IPV4AddressUtil.NULL_IPV4ADDRESS; // ignored
    /**
     * 
     */
    public IGMPV1QueryPacket() {
        super();
        super.setDestinationAddress(IGMPConstants.ALL_HOSTS_ADDRESS);
    }

    /**
     * @param header
     */
    public IGMPV1QueryPacket(IPV4PacketHeader header, ByteBuffer dataBuffer) {
        super(header);
        //this.maxResponseTime=dataBuffer.get(); // IGMPv2
        dataBuffer.get(); // field: unused
        dataBuffer.getShort(); // field: checksum
        // this.groupAddress=IPV4AddressUtil.readAddress(dataBuffer);
    }

  

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.ip.IPV4Packet#getDataLengt()
     */
    protected int getDataLengt() {
        return 8; // TODO change me in the IGMPV3 implementation
    }

    public void setDestinationAddress(Inet4Address destinationAddress) {
        throw new IllegalArgumentException("destination address of the IGMP-Query cannot be changed");
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.ip.IPV4Packet#serializeData(java.nio.ByteBuffer)
     */
    protected void serializeDataInternal(ByteBuffer buffer) {
    	int startPosition=buffer.position();
        buffer.put((byte) 0x11);
        // buffer.put(maxResponseTime); // IGMPv2
        buffer.put((byte)0x00); // set zero for IGMPv1
        buffer.putShort((short)0); // set zero for cecksum
        buffer.putInt(0); // set zero for host membership query message
        
        
    }
}
