/*
 * Created on Oct 8, 2004
 *
 */
package ch.unibe.iam.mcast.net.ip.igmp;

import java.net.Inet4Address;
import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
//import ch.unibe.iam.mcast.ip.util.IPV4AddressUtil;

/**
 * @author dragan
 *
 */
public class IGMPV2QueryPacket extends IGMPPacket {

    private byte maxResponseTime; // IGMPv2
    
    
    /**
     * 
     */
    public IGMPV2QueryPacket(float maxResponseTime) {
        super();
        super.setDestinationAddress(IGMPConstants.ALL_HOSTS_ADDRESS);
    }
    

    public IGMPV2QueryPacket(float maxResponseTime, Inet4Address groupAddress) {
        super();
        super.setDestinationAddress(groupAddress);
    }

    /**
     * @param header
     */
    IGMPV2QueryPacket(IPV4PacketHeader header, ByteBuffer dataBuffer) {
        super(header);        
        this.maxResponseTime=dataBuffer.get(); // field: unused
        dataBuffer.getShort(); // field: checksum        
    }

  

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.ip.IPV4Packet#getDataLengt()
     */
    protected int getDataLengt() {
        return 8; // TODO change me in the IGMPV3 implementation
    }

    public void setDestinationAddress(Inet4Address destinationAddress) {
        throw new IllegalArgumentException("destination address of the IGMP-Query cannot be changed");
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.ip.IPV4Packet#serializeData(java.nio.ByteBuffer)
     */
    protected void serializeDataInternal(ByteBuffer buffer) {
    	int startPosition=buffer.position();
        buffer.put((byte) 0x11);
        // buffer.put(maxResponseTime); // IGMPv2
        buffer.put(maxResponseTime); // set zero for IGMPv1
        buffer.putShort((short)0); // set zero for cecksum
        buffer.putInt(0); // set zero for host membership query message
        
        
    }
}
