package ch.unibe.iam.mcast.net.ip.option;

import java.net.Inet4Address;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import ch.unibe.iam.mcast.net.ip.HeaderOption;

/**
 * @author dragan
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class AbstractHostList extends HeaderOption {
	
	private final List addresses=new ArrayList();
	private byte pointer;

	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.option.HeaderOption#serialize(java.nio.ByteBuffer)
	 */
	public void serializeContent(ByteBuffer buffer) {
		buffer.put(pointer);
		for (Iterator i=addresses.iterator(); i.hasNext();) {
			Inet4Address addr=(Inet4Address)i.next();
			buffer.put(addr.getAddress());
		}
	}

	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.option.HeaderOption#deserialize(java.nio.ByteBuffer)
	 */
	public void deserializeContent(ByteBuffer buffer) {
		this.pointer=buffer.get();
		byte[] adrBuffer=new byte[4];
		while (buffer.hasRemaining()) {
			buffer.get(adrBuffer);
			try {
				Inet4Address adr=(Inet4Address) Inet4Address.getByAddress(adrBuffer);
				addresses.add(adr);
			} catch (UnknownHostException e) {
				throw new RuntimeException("This should never happend (unknown host exception while fetching address from byte[])",e);
			}
		}

	}

	/* (non-Javadoc)
	 * @see ch.unibe.iam.mcast.ip.option.HeaderOption#getLength()
	 */
	public int getContentLength() {
		return 1+addresses.size()*4;
	}

	

}
