/*
 * Created on Oct 8, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ip.option;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.HeaderOption;

/**
 * @author dragan
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HeaderOptionFactory {
    
    private static final Class[] knownTypes=new Class[255];
    
    static {
    	
    	
        //knownTypes[HeaderOptionTypes.END_OF_LIST]=EndOfOptionList.class;
        knownTypes[HeaderOptionTypes.NO_OPERATION & 0xff]=NoOperation.class;
        knownTypes[HeaderOptionTypes.SECURITY & 0xff]=Security.class;
        knownTypes[HeaderOptionTypes.LOOSE_SOURCE_ROUTING & 0xff]=LooseSourceAndRecordRoute.class;
        knownTypes[HeaderOptionTypes.STRICT_SOURCE_ROOTING & 0xff]=StrictSourceAndRecordRoute.class;
        knownTypes[HeaderOptionTypes.RECORD_ROUTE & 0xff]=RecordRoute.class;
        knownTypes[HeaderOptionTypes.STREAM_IDENTIFIER & 0xff]=StreamIdentifier.class;
        
        
        // TODO implement the timestamp options
    }
    
    public static HeaderOption createHeaderOption(byte type, ByteBuffer buffer) {
        HeaderOption ret=constructKnownHeaderOption(type,buffer);
        if (ret == null) {
           ret = createUnknownHeaderOption(type, buffer);
        }
        
        return ret;
    }

    /**
     * @param type
     * @param buffer
     * @return
     */
    private static HeaderOption createUnknownHeaderOption(byte type, ByteBuffer buffer) {
        HeaderOption ret;
        ret=new UnknownHeaderOption(type);
           ret.deserialize(buffer);
        return ret;
    }

    /**
     * @param type
     * @param buffer
     * @return
     */
    private static HeaderOption constructKnownHeaderOption(byte type, ByteBuffer buffer) {
        Class c=knownTypes[type&0xff];
        HeaderOption ret=null;
        if (c != null) {
            try {
                ret=(HeaderOption) c.newInstance();
                ret.deserialize(buffer);
            } catch (InstantiationException e) {
                throw new RuntimeException(e);
            } catch (IllegalAccessException e) {
                throw new RuntimeException(e);
            }
            
        } 
      
        return ret;
    }

}
