/*
 * Created on Dec 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ip.tcp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPProtocolPacketFactory;
import ch.unibe.iam.mcast.net.ip.IPV4Packet;
import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
import ch.unibe.iam.mcast.net.ip.MalformedPacketException;

/**
 * @author root
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TCPPacketFactory implements IPProtocolPacketFactory {

    /**
     * 
     */
    public TCPPacketFactory() {
        super();
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.ip.IPProtocolPacketFactory#createPacket(ch.unibe.iam.mcast.net.ip.IPV4PacketHeader, java.nio.ByteBuffer)
     */
    public IPV4Packet createPacket(IPV4PacketHeader header, ByteBuffer dataBuffer) throws MalformedPacketException {
        
        //System.out.println("deserializing: "dataBuffer.)
        
        if (dataBuffer.remaining() < 20) {
            throw new MalformedPacketException("tcp packet shorter than 20 bytes");
        }
        short sourcePort=dataBuffer.getShort();
        short destinationPort=dataBuffer.getShort();
        long sequenceNumber = dataBuffer.getLong();
        long ackNumber = dataBuffer.getLong();
        int dataOffset = ((dataBuffer.getShort() >> 12) & 0x0f) * 4;
        short window = dataBuffer.getShort(); 
        short checksum=dataBuffer.getShort();
        
        int dataLength=(header.getTotalLength() - header.getHeaderLength() - dataOffset);
        
        if (dataLength < dataBuffer.remaining()) {
            throw new MalformedPacketException("data length ("+dataLength+") of the tcp packet is smaller than buffer length ("+dataBuffer.remaining()+")");
        }
        
        if (dataLength > dataBuffer.remaining()) {
            throw new MalformedPacketException("data length ("+dataLength+") of the tcp packet is bigger than buffer length ("+dataBuffer.remaining()+")");
        }
        
        byte[] data=new byte[dataLength];
        dataBuffer.get(data);
        return new TCPPacket(header,sourcePort,destinationPort,checksum,data);
    }

}
