/*
 * Created on Dec 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ip.udp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPV4Packet;
import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
import ch.unibe.iam.mcast.net.ip.IPProtocolConstants;
import ch.unibe.iam.mcast.net.ip.util.ByteBufferUtil;
import ch.unibe.iam.mcast.net.ip.util.InternetChecksumUtil;

/**
 * @author root
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class UDPPacket extends IPV4Packet {
    
    private final short sourcePort;
    private final short destinationPort;
    private final short checksum;
    
    private final byte[] data;

    
    
    public UDPPacket(IPV4PacketHeader header,short sourcePort, short destinationPort, short checksum, byte[] data) {
        super(header);
        this.sourcePort=sourcePort;
        this.destinationPort=destinationPort;
        this.checksum=checksum;
        this.data=data;
    }
    
    public UDPPacket(short sourcePort, short destinationPort, byte[] data) {
        super(IPProtocolConstants.UDP);
        this.sourcePort=sourcePort;
        this.destinationPort=destinationPort;
        this.checksum=0;
        this.data=data;
    }
    

    protected int getDataLengt() {   
        return 8+data.length;
    }
    
    protected void serializeData(ByteBuffer buffer) {
        
      //  ByteBuffer checksumBuffer=ByteBuffer.allocate(getDataLengt()+12);
//        checksumBuffer.put(getSourceAddress().getAddress());
//        checksumBuffer.put(getDestinationAddress().getAddress());
//        checksumBuffer.put((byte)0);
//        checksumBuffer.put(getProtocol());
//        //System.out.println("protocol: "+getProtocol());
//        checksumBuffer.putShort((short)getDataLengt());
        
        
        int startPosition=buffer.position();
        buffer.putShort(sourcePort);
        //checksumBuffer.putShort(sourcePort);
        
        buffer.putShort(destinationPort);
        //checksumBuffer.putShort(destinationPort);
        
        short length=(short)getDataLengt();
        buffer.putShort(length);
        //checksumBuffer.putShort(length);
        
        
        int checksumPosition=buffer.position();
        buffer.putShort((short)0);
        //checksumBuffer.putShort((short)0);
        
        buffer.put(data);
        //checksumBuffer.put(data);
        
        int currentPosition=buffer.position();
        int currentLimit=buffer.limit();
        buffer.position(startPosition);
        buffer.limit(currentPosition);
        
        
        int sum=InternetChecksumUtil.updateSum(0,getSourceAddress().getAddress());
        sum=InternetChecksumUtil.updateSum(sum,getDestinationAddress().getAddress());
        sum=InternetChecksumUtil.updateSum(sum,(short)(getProtocol() & 0xff));
        sum=InternetChecksumUtil.updateSum(sum,(short)(length));
        
        
        
        short udpChecksum = InternetChecksumUtil.computeInetChecksum(sum,buffer);
        //System.out.println("old checksum: "+udpChecksum);
        
//        checksumBuffer.limit(checksumBuffer.position());
//        checksumBuffer.position(0);
//        short newUdpChecksum=InternetChecksumUtil.computeInetChecksum(checksumBuffer);
        //System.out.println("new checksum: "+newUdpChecksum);
        
//        System.out.println("checksum:");
//        ByteBufferUtil.dumpByteBuffer(checksumBuffer);
//        System.out.println("only udp:");
//        ByteBufferUtil.dumpByteBuffer(buffer);
        
        buffer.position(currentPosition);
        buffer.limit(currentLimit);
        //buffer.putShort(checksumPosition,newUdpChecksum);
        

    }


    /**
     * @param length
     * @return
     */
    private short computeUDPChecksum(short length) {
        
        // FIXME find the checksum problem
        if (false) {
            return (short) 0x9a66;
        }
        int sum=InternetChecksumUtil.updateSum(0,getSourceAddress().getAddress());
        sum=InternetChecksumUtil.updateSum(sum,getDestinationAddress().getAddress());
        sum=InternetChecksumUtil.updateSum(sum,(short)(getProtocol() & 0xff));
        sum=InternetChecksumUtil.updateSum(sum,length);
        
        sum=InternetChecksumUtil.updateSum(sum,sourcePort);
        sum=InternetChecksumUtil.updateSum(sum,destinationPort);
        sum=InternetChecksumUtil.updateSum(sum,length);
        sum=InternetChecksumUtil.updateSum(sum,(short)0);
        short udpChecksum=InternetChecksumUtil.normalizeSum(sum);
        return udpChecksum;
    }
}
