/*
 * Created on Dec 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.unibe.iam.mcast.net.ip.udp;

import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.net.ip.IPProtocolPacketFactory;
import ch.unibe.iam.mcast.net.ip.IPV4Packet;
import ch.unibe.iam.mcast.net.ip.IPV4PacketHeader;
import ch.unibe.iam.mcast.net.ip.MalformedPacketException;

/**
 * @author root
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class UDPPacketFactory implements IPProtocolPacketFactory {

    /**
     * 
     */
    public UDPPacketFactory() {
        super();
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @see ch.unibe.iam.mcast.net.ip.IPProtocolPacketFactory#createPacket(ch.unibe.iam.mcast.net.ip.IPV4PacketHeader, java.nio.ByteBuffer)
     */
    public IPV4Packet createPacket(IPV4PacketHeader header, ByteBuffer dataBuffer) throws MalformedPacketException {
        
        //System.out.println("deserializing: "dataBuffer.)
        
        if (dataBuffer.remaining() < 8) {
            throw new MalformedPacketException("udp packet shorter than 8 bytes");
        }
        short sourcePort=dataBuffer.getShort();
        short destinationPort=dataBuffer.getShort();
        int dataLength=(dataBuffer.getShort() & 0xffff) -8 ;
        
        
        
        short checksum=dataBuffer.getShort();
        
        if (dataLength < dataBuffer.remaining()) {
            throw new MalformedPacketException("data length ("+dataLength+") of the udp packet is smaller than buffer length ("+dataBuffer.remaining()+")");
        }
        
        if (dataLength > dataBuffer.remaining()) {
            throw new MalformedPacketException("data length ("+dataLength+") of the udp packet is bigger than buffer length ("+dataBuffer.remaining()+")");
        }
        
        byte[] data=new byte[dataLength];
        dataBuffer.get(data);
        return new UDPPacket(header,sourcePort,destinationPort,checksum,data);
    }

}
