/*
 * Created on Feb 12, 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package ch.unibe.iam.mcast.net.ip.util;

import java.io.PrintWriter;
import java.nio.ByteBuffer;

/**
 * @author dragan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ByteBufferUtil {

    
	private static final int minimalBufferSize=512;
	private static final int minimalOverhead=128;


	private static char getPrintable(byte b) {
		char ret= (char) (((int) b) & 0xff);

		if (ret >= '0' && ret <= '9')
			return ret;

		if (Character.isLetterOrDigit(ret))
			return ret;

		if (Character.isWhitespace(ret))
			return ' ';

		return '.';
	}

	public static void dumpByteBuffer(ByteBuffer buffer) {
		dumpByteBuffer(buffer, 4);
	}

	public static void dumpByteBuffer(ByteBuffer buffer, int width) {
		StringBuffer sb=new StringBuffer();
		dumpByteBufferToPrintWriter(buffer, new PrintWriter(System.out), width);
		System.out.println(sb);
		
		
	}
	
	public static String byteBufferToString(ByteBuffer buffer) {
		
		ByteBuffer copy= buffer.duplicate();
		StringBuffer hex= new StringBuffer();
		while (copy.remaining() > 0) {
			byte b= copy.get();
			hex.append(ByteUtil.toHex(b));
			hex.append(" ");
		}
		return hex.toString();
	}

	/**
	 * @param buffer
	 * @param width
	 */
	public static void dumpByteBufferToPrintWriter(ByteBuffer buffer, PrintWriter pw, int width) {
		ByteBuffer copy= buffer.duplicate();

		StringBuffer ascii= new StringBuffer();
		StringBuffer hex= new StringBuffer();

		int count= 0;
		

		while (copy.remaining() > 0) {
			count++;

			byte b= copy.get();
			
			ascii.append(getPrintable(b));
		
			hex.append(ByteUtil.toHex(b));
			hex.append(" ");
			/*
			if  (copy.remaining() > 0) {
				
			}*/

			if (count % width == 0) {
				System.out.println(hex + "\t" + ascii);			
				ascii.setLength(0);
				hex.setLength(0);
			}

		}

		if (hex.length() > 0) {
			while (count++ % width != 0) {
				hex.append("   ");
				ascii.append(" ");
			}
			//hex.setLength(hex.length()-1);
			pw.println(hex + "\t" + ascii);
			
		}
	}
	

	
	
}
