/*
 * Created on Oct 8, 2004
 *
 */
package ch.unibe.iam.mcast.net.ip.util;

import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;

/**
 * @author dragan
 *
 */
public class IPV4AddressUtil {
    
    public static final Inet4Address NULL_IPV4ADDRESS;

    static {
        byte[] address = new byte[4];
        try {
            NULL_IPV4ADDRESS = (Inet4Address) InetAddress.getByAddress(address);
        } catch (UnknownHostException e) {
            throw new RuntimeException("this should never happend", e);
        }
    } 

    public static Inet4Address readAddress(ByteBuffer buffer) {
        byte[] adrBuffer=new byte[4];
        buffer.get(adrBuffer);
        return byteArrayToInet4Address(adrBuffer);
        
    }

    /**
     * @param adrBuffer
     * @return
     */
    public static Inet4Address byteArrayToInet4Address(byte[] adrBuffer) {
        try {
            return (Inet4Address) InetAddress.getByAddress(adrBuffer);
        } catch (UnknownHostException e) {
            throw new RuntimeException("this should never happend",e);
        }
    }
    
    

}
