/*
 * Created on Mar 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package ch.unibe.iam.mcast.net.ip.util;

import java.nio.ByteBuffer;

/**
 * @author root
 * 
 * To change the template for this generated type comment go to Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class InternetChecksumUtil {

    public static short computeInetChecksum(ByteBuffer buffer) {
        return computeInetChecksum(0, buffer);
    }

    public static short computeInetChecksum(int initialState, ByteBuffer buffer) {

        //        System.out.println("computing checksum with initial state "+initialState);
        //        ByteBufferUtil.dumpByteBuffer(buffer);

        int sum = initialState;

        int startPosition = buffer.position();
        //int counter = 0;
        while (buffer.remaining() > 1) {
//            if ((counter++ % 4) == 0) {
//                System.out.println("preliminary(" + (counter - 1) + "): " + sum);
//            }
            sum += buffer.getShort() & 0xffff;

        }

        if (buffer.remaining() != 0) {
            sum += (buffer.get() & 0xff) << 8;
        }

        while ((sum >> 16) != 0) {
            sum = (sum & 0xffff) + ((sum >> 16) & 0xffff);
        }

        buffer.position(startPosition);

        return (short) (~sum);
    }

    public static int updateSum(int oldSum, short data) {
        oldSum += (data & 0xffff);
        return oldSum;
    }

    public static int updateSum(int oldSum, int data) {
        oldSum += ((data >> 16) & 0xffff);
        oldSum += data & 0xffff;
        return oldSum;
    }

    public static int updateSum(int oldSum, byte[] data) {
        int pos = 0;
        while (data.length - pos > 1) {
            short dat = (short) (data[pos] << 8 | data[pos + 1]);
            oldSum += (dat & 0xffff);
            pos += 2;
        }
        if (data.length - pos != 0) {
            oldSum += data[pos] & 0xff;
        }
        return oldSum;
    }

    public static short normalizeSum(int sum) {
        while ((sum >> 16) != 0) {
            sum = (sum & 0xffff) + ((sum >> 16) & 0xffff);
        }
        return (short) (~sum);
    }

    public static void main(String[] argv) {
        int ai = 0x01020304;
        byte[] aa = new byte[] { 0x01, 0x02, 0x03, 0x04 };
        short as0 = 0x0102;
        short as1 = 0x0304;
        int sum = updateSum(0, ai);
        int sum2 = updateSum(0, aa);
        int sum3 = updateSum(0, as0);
        sum3 = updateSum(sum3, as1);
        System.out.println("sum: " + sum);
        System.out.println("sum2: " + sum2);
        System.out.println("sum3: " + sum3);
        
        System.out.println("sumx: "+normalizeSum(sum));
        
        
        ByteBuffer bb=ByteBuffer.allocate(4);
        bb.putInt(ai);
        bb.position(0);
        System.out.println("byte buffer sum: "+computeInetChecksum(0,bb));
        
        ByteBuffer bb2=ByteBuffer.allocate(2);
        bb2.putShort(as1);
        bb2.position(0);
        System.out.println("byte buffer sum: "+computeInetChecksum(updateSum(0, as0),bb2));

    }

}