package ch.unibe.iam.mcast.router.p2p;

import java.net.InetSocketAddress;

public class ConnectionInformation {

		private final InetSocketAddress localAddress;
		private final InetSocketAddress remoteAddress;

		public ConnectionInformation(InetSocketAddress localAddress, InetSocketAddress remoteAddress) {
			if (localAddress == null) {
				throw new RuntimeException("local address should not be null");
			}
			this.localAddress = localAddress;
			if (remoteAddress == null) {
				throw new RuntimeException("remote address should not be null");
			}
			this.remoteAddress = remoteAddress;
			
		}

		public InetSocketAddress getLocalAddress() {
			return localAddress;
		}

		public InetSocketAddress getRemoteAddress() {
			return remoteAddress;
		}

		@Override
		public boolean equals(Object obj) {
			if (!(obj instanceof ConnectionInformation)) {
				return false;
			}			
			ConnectionInformation other=(ConnectionInformation) obj;
			return this.localAddress.equals(other.localAddress) && this.remoteAddress.equals(other.remoteAddress);				
		}

		@Override
		public int hashCode() {			
			return localAddress.hashCode() ^ remoteAddress.hashCode();
		}

		@Override
		public String toString() {			
			return "[local: "+localAddress+", remote: "+remoteAddress+"]";
		}

}
