package ch.unibe.iam.mcast.router.p2p.message.euqos;

import java.net.InetAddress;
import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.router.p2p.message.MalformedP2PMessageException;
import ch.unibe.iam.mcast.router.p2p.message.P2PMessage;
import ch.unibe.iam.mcast.router.p2p.message.P2PMessageConstants;
import ch.unibe.iam.mcast.router.p2p.message.P2PObjectUtil;

public class ChildHelloMessage extends P2PMessage {
	
	private InetAddress groupAddress;
	private String peerId;
	 

	public ChildHelloMessage() {
		super(P2PMessageConstants.CHILD_HELLO_MESSAGE);
	}

	public ChildHelloMessage(InetAddress groupAddress,String peerId) {
		this();
		this.groupAddress=groupAddress;
		this.peerId = peerId;
		
	}

	@Override
	protected int contentLength() {		
		return peerId.length()*2+4+groupAddress.getAddress().length+4;
	}

	@Override
	protected void deserializeContent(ByteBuffer buffer) throws MalformedP2PMessageException {
		this.peerId=P2PObjectUtil.deserializeString(buffer);
		this.groupAddress=P2PObjectUtil.deserializeInetAddress(buffer);
		
	}

	public String getPeerId() {
		return peerId;
	}

	@Override
	protected void serializeContent(ByteBuffer buffer) {
		P2PObjectUtil.serializeString(peerId, buffer);
		P2PObjectUtil.serializeInetAddress(groupAddress, buffer);
		
	}

	public InetAddress getGroupAddress() {
		return groupAddress;
	}

}
