package ch.unibe.iam.mcast.router.p2p.message.euqos;

import java.net.InetAddress;
import java.nio.ByteBuffer;

import ch.unibe.iam.mcast.router.p2p.message.MalformedP2PMessageException;
import ch.unibe.iam.mcast.router.p2p.message.P2PMessage;
import ch.unibe.iam.mcast.router.p2p.message.P2PMessageConstants;
import ch.unibe.iam.mcast.router.p2p.message.P2PObjectUtil;

public class ParentHelloMessage extends P2PMessage {
	

	private String peerId;
	private InetAddress groupAddress;

	public ParentHelloMessage(String peerId, InetAddress groupAddress) {
		this();
		this.peerId=peerId;
		this.groupAddress=groupAddress;
	}
	
	public ParentHelloMessage() {
		super(P2PMessageConstants.PARENT_HELLO_MESSAGE);		
	}
	
	
	@Override
	protected int contentLength() {
		// TODO Auto-generated method stub
		return peerId.length()*2+4+groupAddress.getAddress().length+4;
	}

	@Override
	protected void deserializeContent(ByteBuffer buffer) throws MalformedP2PMessageException {
		this.peerId=P2PObjectUtil.deserializeString(buffer);
		this.groupAddress=P2PObjectUtil.deserializeInetAddress(buffer);
		
	}

	@Override
	protected void serializeContent(ByteBuffer buffer) {
		P2PObjectUtil.serializeString(peerId, buffer);
		P2PObjectUtil.serializeInetAddress(groupAddress, buffer);		
	}

	public InetAddress getGroupAddress() {
		return groupAddress;
	}
	
	public String getPeerId() {
		return peerId;
	}

}
