package ch.unibe.iam.mcast.router.pastry;

import java.util.concurrent.TimeoutException;

import EDU.oswego.cs.dl.util.concurrent.misc.SynchronizationTimer;

import rice.p2p.commonapi.Message;



public class Future<T,E extends Throwable> {

	private T value;

	private E exception;
	
	private boolean set;

	public Future() {

	}

	public synchronized T get(long timeout) throws TimeoutException, InterruptedException, E {
		if (timeout < 0 ) {
			throw new RuntimeException("negative timeout");
		}
		long deadline=(timeout == 0) ? Long.MAX_VALUE : System.currentTimeMillis()+timeout;
		while (!set) {
			timeout=deadline-System.currentTimeMillis();
			if (set) {
				return value;
			}
			if (timeout <= 0) {
				throw new TimeoutException("timeout expired");
			}
			wait(timeout);
		}
		
		if (exception != null) {
			throw exception;
		}
		return value;
	}

	public synchronized void set(T value) {
		this.value=value;
		this.set=true;
		notifyAll();
	}
	
	public synchronized void setException(E exception) {
		this.exception=exception;
	}

}
