package ch.unibe.iam.mcast.router.pastry;

import java.util.concurrent.TimeoutException;

import rice.p2p.commonapi.Message;



public class MessageFuture {

	private Message message;

	private boolean set;

	public MessageFuture() {

	}

	public synchronized Message get(long timeout) throws TimeoutException, InterruptedException {
		if (timeout < 0 ) {
			throw new RuntimeException("negative timeout");
		}
		long deadline=(timeout == 0) ? Long.MAX_VALUE : System.currentTimeMillis()+timeout;
		while (!set) {
			timeout=deadline-System.currentTimeMillis();
			if (set) {
				return message;
			}
			if (timeout <= 0) {
				throw new TimeoutException("timeout expired");
			}
			wait(timeout);
		}
		return message;
	}

	public synchronized void set(Message message) {
		this.message=message;
		this.set=true;
		notifyAll();
	}

}
