package ch.unibe.iam.mcast.router.pastry.message;

import java.net.InetAddress;

import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.Message;



public class ConfirmMessage extends DHTMessage {


	private final InetAddress group;
	private final Id sender;

	public ConfirmMessage(Id sender, InetAddress group) {
		this.sender = sender;
		this.group = group;
	}

	public InetAddress getGroup() {
		return group;
	}

	public int getPriority() {
		return MEDIUM_PRIORITY;
	}

	public Id getSender() {
		return sender;
	}
	
	@Override
	public String toString() {
		return "Confirm(Group:"+group.getHostAddress()+" from "+sender.toStringFull()+")";
	}
	

}
