package ch.unibe.iam.mcast.router.pastry.message;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.List;

import rice.p2p.commonapi.Message;


public class JoinToMessage extends DHTResponseMessage {

	private final InetAddress group;
	private final List<InetSocketAddress> bootstrapPoints;
//	private final Id sender;
	
	public JoinToMessage(InetAddress group, List<InetSocketAddress> bootstrapPoints) {
		
//		this.sender = sender;
		this.group = group;
		this.bootstrapPoints = bootstrapPoints;		
	}

	public List<InetSocketAddress> getBootstrapPoints() {
		return bootstrapPoints;
	}

	public InetAddress getGroup() {
		return group;
	}

//	public Id getSender() {
//		return sender;
//	}

	public int getPriority() {
		return MEDIUM_PRIORITY;
	}
	
	public String toString() {
		return "JoinTo(Group:"+group.getHostAddress()+" bootstraps "+bootstrapPoints+")";
	}
}
