package ch.unibe.iam.mcast.router.pastry.message;

import java.net.InetAddress;
import java.net.InetSocketAddress;

import rice.p2p.commonapi.Id;


public class JoinedMessage extends DHTMessage {

	private final InetAddress group;
	private final InetSocketAddress endpoint;
	private final Id sender;

	public JoinedMessage(Id sender, InetAddress group, InetSocketAddress endpoint) {
		this.sender = sender;
		this.group = group;
		this.endpoint = endpoint;
	}

	public InetAddress getGroup() {
		return group;
	}

	public InetSocketAddress getEndpoint() {
		return endpoint;
	}

	public int getPriority() {
		return MEDIUM_PRIORITY;
	}

	public Id getSender() {
		return sender;
	}
	
	public String toString() {
		return "Joined(Group:"+group.getHostAddress()+" endpoint "+endpoint+" from "+sender.toStringFull()+")";
	}
}
