package ch.unibe.iam.mcast.router.pastry.message;

import java.net.InetAddress;
import java.net.InetSocketAddress;

import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.Message;

public class LeftMessage extends DHTMessage {

	private final InetAddress group;
	private final Id sender;
	private final InetSocketAddress endpoint;
	
	public Id getSender() {
		return sender;
	}

	public LeftMessage(Id sender, InetAddress group, InetSocketAddress endpoint) {
		this.sender = sender;
		this.group = group;
		this.endpoint = endpoint;
	}

	public InetAddress getGroup() {
		return group;
	}

	public int getPriority() {
		return MEDIUM_PRIORITY;
	}

	public InetSocketAddress getEndpoint() {
		return endpoint;
	}
	
	public String toString() {
		return "Left(Group:"+group.getHostAddress()+" endpoint "+endpoint+" from "+sender.toStringFull()+")";
	}

}
