package ch.unibe.iam.mcast.router.pastry.past;

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Date;
import java.util.Timer;

import rice.p2p.commonapi.Id;
import rice.p2p.past.PastContent;
import rice.p2p.past.PastException;

public class CreateNewRingContent extends GroupBootstrapContent implements Serializable {
	
	
	private long expirationTime;

	private final Id bootstrapId;

	public CreateNewRingContent(Id id, Id bootstrapId) {
		super(id);
		this.bootstrapId = bootstrapId;
		this.expirationTime = System.currentTimeMillis() + 5000;
	}

	public String toString() {
		return "CreateNewRingContent[time: "+new Date(expirationTime).toString()+", id: "+getId()+", nodeId:"+bootstrapId+"]";
	}
	
	public PastContent checkInsertHook(Id id, PastContent existingContent) throws PastException {
//		System.out.println("create new ring content check insert");
		throw new RuntimeException("this method should never be called");
	}

//	private synchronized void writeObject(java.io.ObjectOutputStream out) throws IOException {
//		long timeBase=System.currentTimeMillis();
//		this.expirationTime-=timeBase;
//		try {
//		out.defaultWriteObject();
//		} catch (IOException ioe) {
//			ioe.printStackTrace();
//		}
//		System.out.println("serialized "+this);
//	}
//
//	private synchronized void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
//		
//		
//		
//		long timeBase=System.currentTimeMillis();
//		this.expirationTime+=timeBase;
//		in.defaultReadObject();	
//		System.out.println("deserialized "+this);
//	}

	public boolean isExpired() {
		return System.currentTimeMillis() > expirationTime;
	}

	public Id getBootstrapId() {
		return bootstrapId;
	}
	
	public static void main(String argv[]) throws IOException {
		CreateNewRingContent cntn = new CreateNewRingContent(null,null);
		do_serialize(cntn);		
	}

	public static void do_serialize(CreateNewRingContent cntn)  {
		ByteArrayOutputStream baos=new ByteArrayOutputStream();
		ObjectOutputStream oos;
		try {
			oos = new ObjectOutputStream(baos);
			oos.writeObject(cntn);
		} catch (IOException e) {
		
			e.printStackTrace();
		}
		
		
		
	}
	

}
