package ch.unibe.iam.mcast.router.pastry.past;

import java.io.IOException;
import java.net.Inet4Address;
import java.util.Timer;

import rice.p2p.commonapi.Id;
import rice.p2p.past.ContentHashPastContentHandle;
import rice.p2p.past.Past;
import rice.p2p.past.PastContent;
import rice.p2p.past.PastContentHandle;
import rice.p2p.past.PastException;

public abstract class GroupBootstrapContent implements PastContent {

	// protected static final Timer timer=new Timer("PastMessage timer");

	private final Id id;

	public GroupBootstrapContent(Id id) {
		this.id = id;

	}

	// public PastContent checkInsert(Id id, PastContent existingContent) throws
	// PastException {
	//		
	// }

	public PastContentHandle getHandle(Past local) {
		return new ContentHashPastContentHandle(local.getLocalNodeHandle(), id);
	}

	public Id getId() {
		return id;
	}

	public boolean isMutable() {
		return true;
	}

	public PastContent checkInsert(Id id, PastContent existingContent) throws PastException {
		if (!(this instanceof PeerAliveContent)) {
			System.out.println("+------------------- Transition start ------------------+");
			System.out.println("pre insert state: " + existingContent);
			System.out.println("transition: " + this);
		}
		PastContent newState = checkInsertHook(id, existingContent);
		if (!(this instanceof PeerAliveContent)) {
			System.out.println("new state: " + newState);
			System.out.println("+------------------- Transition end --------------------+");
		}
		return newState;
	}

	public abstract PastContent checkInsertHook(Id id, PastContent existingContent) throws PastException;

	// private synchronized void writeObject(java.io.ObjectOutputStream out)
	// throws IOException {
	// try {
	// out.defaultWriteObject();
	// } catch (IOException ioe) {
	// ioe.printStackTrace();
	// }
	// System.out.println("serialized "+this);
	// }
	//
	// private synchronized void readObject(java.io.ObjectInputStream in) throws
	// IOException, ClassNotFoundException {
	// in.defaultReadObject();
	// System.out.println("deserialized "+this);
	// }

}
