package ch.unibe.iam.mcast.router.pastry.past;

import java.net.InetSocketAddress;

import rice.p2p.commonapi.Id;
import rice.p2p.past.PastContent;
import rice.p2p.past.PastException;

public class LeavingGroupContent extends GroupBootstrapContent {

	private final Id bootstrapId;
	private final InetSocketAddress endpoint;

	public LeavingGroupContent(Id id, Id bootstrapId, InetSocketAddress endpoint) {
		super(id);
		this.bootstrapId = bootstrapId;
		this.endpoint = endpoint;
	}

	public PastContent checkInsertHook(Id id, PastContent existingContent) throws PastException {
//		System.out.println("leaving group content check insert");
		if (existingContent instanceof CreateNewRingContent) {
			CreateNewRingContent cnrc = (CreateNewRingContent) existingContent;
			if (cnrc.getBootstrapId().equals(bootstrapId)) {
				return null;
			}
		} else if (existingContent instanceof ActiveRingContent) {
			ActiveRingContent active=(ActiveRingContent) existingContent;
			active.remove(endpoint);
			return active;
		}
		return existingContent;

	}

		public String toString() {
			return "LeavingGroupContent[id: "+bootstrapId+", endpoint: "+endpoint+"]";
		}
}
