package ch.unibe.iam.mcast.router.pastry.past;

import rice.p2p.commonapi.Id;
import rice.p2p.past.PastContent;
import rice.p2p.past.PastException;

public class OfferNewRingContent extends GroupBootstrapContent {

	private final Id nodeId;

	public OfferNewRingContent(Id id, Id nodeId) {
		super(id);
		this.nodeId = nodeId;
	}

	public PastContent checkInsertHook(Id id, PastContent existingContent) throws PastException {
		
		System.out.println("offer new ring content check insert");
		if (existingContent instanceof CreateNewRingContent) {
			CreateNewRingContent cnr = (CreateNewRingContent) existingContent;
			if (cnr.isExpired()) {
				CreateNewRingContent createNewRingContent = new CreateNewRingContent(getId(), nodeId);
				return createNewRingContent;
			} else {
				return existingContent;
			}
		} else if (existingContent instanceof ActiveRingContent) {
			ActiveRingContent arc = (ActiveRingContent) existingContent;
			if (arc.getBootstrapEntries().isEmpty()) {
				CreateNewRingContent createNewRingContent = new CreateNewRingContent(getId(), nodeId);
				return createNewRingContent;
			} else {
				return arc;
			}
		} else if (existingContent == null) {
			System.out.println("+++ content is null");
			CreateNewRingContent createNewRingContent = new CreateNewRingContent(id,nodeId);
			CreateNewRingContent.do_serialize(createNewRingContent);
			return createNewRingContent;
		} else {
			return existingContent;
		}
	}

	public Id getNodeId() {
		return nodeId;
	}
	
	public String toString() {
		return "OfferNewRingContent[id: "+getId()+", nodeId: "+nodeId+"]";
	}

}
