package ch.unibe.iam.mcast.router.pastry.past;

import java.net.InetSocketAddress;

import rice.p2p.commonapi.Id;
import rice.p2p.past.PastContent;
import rice.p2p.past.PastException;

public class PeerAliveContent extends GroupBootstrapContent {

	private final InetSocketAddress address;
	private final Id nodeId;

	public PeerAliveContent(Id id, Id nodeId, InetSocketAddress address) {
		super(id);
		this.nodeId = nodeId;
		// TODO Auto-generated constructor stub
		this.address = address;
	}

	public PastContent checkInsertHook(Id id, PastContent existingContent) throws PastException {

//		System.out.println("peer alive content check insert: " + existingContent);

		if (existingContent instanceof ActiveRingContent) {
			ActiveRingContent arc = (ActiveRingContent) existingContent;
			arc.refresh(address);
			return existingContent;
		} else if (existingContent instanceof CreateNewRingContent) {
			CreateNewRingContent cnrc=(CreateNewRingContent) existingContent;
			if (cnrc.getBootstrapId().equals(nodeId)) {
				ActiveRingContent arc=new ActiveRingContent(id,nodeId);
				arc.refresh(address);
				return arc;
			} else {
				return existingContent;
			}
		} else if (existingContent == null) {
			
			
			ActiveRingContent arc=new ActiveRingContent(id,nodeId);
			arc.refresh(address);
			System.out.println("warning, something went wrong, no group info !"+arc);
			return arc;			
		}
		return existingContent;

	}

	public InetSocketAddress getAddress() {
		return address;
	}

	public String toString() {
		return "PeerAliveContent[id: "+getId()+", nodeId: "+nodeId+", endpoint: "+getAddress()+"]";
	}
	
}
