package ch.unibe.iam.mcast.router.qos;

import java.net.InetAddress;
import java.util.HashMap;
import java.util.Map;

public class QoSInformation {

	private final Map<InetAddress, QoSRequirement> groupToReq = new HashMap<InetAddress, QoSRequirement>();

	private static final QoSRequirement NULL_REQUIREMENT = new QoSRequirement(0, 0, 0);

	public QoSInformation() {

	}

	public synchronized void addRequirement(InetAddress group, QoSRequirement req) {
		if (req.equals(NULL_REQUIREMENT)) {
			groupToReq.remove(group);
		} else {
			groupToReq.put(group, req);
		}
	}

	public synchronized QoSRequirement getRequirement(InetAddress group) {
		if (groupToReq.containsKey(group)) {
			return groupToReq.get(group);
		} else {
			return NULL_REQUIREMENT;
		}
	}

	public synchronized void removeRequirement(InetAddress group) {
		groupToReq.remove(group);
	}

}
