package ch.unibe.iam.mcast.router.qos;

public class QoSRequirement implements Comparable<QoSRequirement> {
	private long bandwidth;

	private int jitter;

	private int delay;

	public QoSRequirement(long bandwidth, int delay, int jitter) {
		this.bandwidth = bandwidth;
		this.jitter = jitter;
		this.delay = delay;
	}

	public long getBandwidth() {
		return bandwidth;
	}

	public int getDelay() {
		return delay;
	}

	public int getJitter() {
		return jitter;
	}

	public int compareTo(QoSRequirement o) {
		return (int)(o.bandwidth - bandwidth);
	}

	@Override
	public boolean equals(Object obj) {
		QoSRequirement other=(QoSRequirement) obj;
		if (other != null) {
			return bandwidth==other.bandwidth;
		} else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return ((int)(bandwidth>>32) ^ (int)bandwidth);
	}
	
	
	public String toString() {
		return "[bw="+bandwidth+" jitter="+jitter+", delay="+delay+"]";
	}

	public boolean isBestEffort() {
		
		return bandwidth == 0 && jitter== 0 && delay ==0; 
	}
	

}
