package ch.unibe.iam.mcast.router.web;

import java.net.InetSocketAddress;
import java.net.UnknownHostException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.mortbay.jetty.Connector;
import org.mortbay.jetty.Server;
import org.mortbay.jetty.nio.SelectChannelConnector;

public class WebappContainer {

	private static final Log log = LogFactory.getLog(WebappContainer.class);

	private final InetSocketAddress bindAddress;

	private Server server = new Server();

	private Connector connector = new SelectChannelConnector();

	public WebappContainer(InetSocketAddress bindAddress) {
		this.bindAddress = bindAddress;
		if (bindAddress.getHostName() != null) {
			connector.setHost(bindAddress.getHostName());
		}
		connector.setPort(bindAddress.getPort());
		server.setConnectors(new Connector[] { connector });
	}

	public void start() throws Exception {
		server.start();
	}

	public void stop() {

		try {
			server.stop();
		} catch (Exception e) {
			log.warn(e);
		}

	}

	public String toString() {
		return "WebappContainer(" + bindAddress + ")";
	}

}
