package ch.unibe.iam.mcast.webapp.ws;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import ch.unibe.iam.mcast.core.LocalNetworkInterface;
import ch.unibe.iam.mcast.core.MulticastRoutingDestination;
import ch.unibe.iam.mcast.core.MulticastRoutingTable;
import ch.unibe.iam.mcast.core.MulticastRoutingTableEntry;

public class QoSService implements ServletContextListener {

    private static MulticastRoutingTable routingTable = null;

    public QoSService() {
        // this.routingTable=router.getMulitcastRoutingTable();
    }

    public void setPriority(String multicastGroupName, int priority) {
        InetAddress multicastGroup;
        try {
            multicastGroup = InetAddress.getByName(multicastGroupName);
        } catch (UnknownHostException e) {
            throw new RuntimeException(e);
        }
        Map m = routingTable.getRoutes();
        Set destinations = (Set) m.get(multicastGroup);
        if (destinations == null) {
            // todo what?
        }
        LocalNetworkInterface lni = null;
        for (Iterator i = destinations.iterator(); i.hasNext();) {
            MulticastRoutingTableEntry entry = (MulticastRoutingTableEntry) i.next();
            MulticastRoutingDestination destination = entry.getDestination();
            if (destination instanceof LocalNetworkInterface) {
                lni = (LocalNetworkInterface) destination;
            }
        }
        if (lni != null) {
            routingTable.removeRoute(multicastGroup, lni);
            routingTable.addRoute(multicastGroup, lni, priority);
        }

    }

    public WSRoutingTableEntry[] getRoutingTable() {
        try {
//            System.out.println("++++ getRoutingTable called");
//
//            if (false) {
//
//                WSRoutingTableEntry[] routingTableEntries = new WSRoutingTableEntry[]{createEntry(),createEntry(),createEntry()};;
//                
//                //createEntry();
//                System.out.println("++++ getRoutingTable finished +++");
//                return routingTableEntries;
//            }
            Map routes = routingTable.getRoutes();
            ArrayList entries=new ArrayList();
            //WSRoutingTableEntry[] ret = new WSRoutingTableEntry[routes.size()];
            int index = 0;
            for (Iterator i = routes.entrySet().iterator(); i.hasNext(); index++) {
                Map.Entry entry = (Entry) i.next();
                InetAddress groupAddress = (InetAddress) entry.getKey();
               
                Set destinations = (Set) entry.getValue();
                int index2 = 0;
               
                for (Iterator i2 = destinations.iterator(); i2.hasNext(); index2++) {
                    MulticastRoutingTableEntry destination = (MulticastRoutingTableEntry) i2.next();
                    
                    WSRoutingTableEntry te=new WSRoutingTableEntry();
                    te.setMulticastGroup(groupAddress.getHostAddress());
                    te.setDestination(destination.getDestination().toString());
                    te.setPriority(destination.getPriority());
                    entries.add(te);
                    
                }
               
            }
//            System.out.println("ret: "+entries);
            return (WSRoutingTableEntry[]) entries.toArray(new WSRoutingTableEntry[0]);
        } catch (Throwable e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        } 
    }

    /**
     * 
     */
    private WSRoutingTableEntry createEntry() {
        WSRoutingTableEntry e1= new WSRoutingTableEntry();
        e1.setMulticastGroup("g1");
        e1.setDestination("d1");
        e1.setPriority(100);
//        WSRoutingDestination dst = new WSRoutingDestination();
//        dst.setDestination("d1");
//        dst.setPriority(100);
//        e1.setDestinations(new WSRoutingDestination[] { dst });
//        System.out.println("e: "+e1);
        return e1;
    }

    public void contextInitialized(ServletContextEvent ctx) {
        routingTable=(MulticastRoutingTable) ctx.getServletContext().getAttribute("multicast.routing.table");
        
    }

    public void contextDestroyed(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
        
    }

}
